package com.tzld.piaoquan.recommend.server.service.score4recall.strategy;

import com.tzld.piaoquan.recommend.server.service.score.ScorerConfigInfo;
import com.tzld.piaoquan.recommend.server.service.score4recall.AbstractScorer4Recall;
import com.tzld.piaoquan.recommend.server.service.score4recall.model4recall.Model4RecallVovLongTerm;
import org.apache.commons.lang3.tuple.Pair;
import java.util.*;

public class RegionRecallScorerV7VovLongTerm extends AbstractScorer4Recall {

    public RegionRecallScorerV7VovLongTerm(ScorerConfigInfo configInfo) {
        super(configInfo);
    }
    @Override
    public void loadModel() {
        doLoadModel(Model4RecallVovLongTerm.class);
    }

    @Override
    public List<Pair<Long, Double>> recall(Map<String, String> params){
        Model4RecallVovLongTerm model = (Model4RecallVovLongTerm) this.getModel();
        Map<String, List<Pair<Long, Double>>> kv = model.kv;
        List<Pair<Long, Double>> result = new ArrayList<>();
        for (Map.Entry<String, String> entry : params.entrySet()) {
            String key = entry.getKey();
            int count = Integer.parseInt(entry.getValue());
            if (kv.containsKey(key)) {
                List<Pair<Long, Double>> copy = new ArrayList<>(kv.get(key));
                // 先随机，再截断。
                Collections.shuffle(copy);
                result.addAll(copy.subList(0, Math.min(count, copy.size())));
            }
        }
        return result;
    }
}